package com.idata.demo;

import java.sql.Connection;
import java.sql.DriverManager;

import com.idata.core.meta.db.DestinationMetaData;
import com.idata.core.meta.db.SourceMetaData;
import com.idata.etl.DataSource;
import com.idata.etl.DataSourceFactory;
import com.idata.etl.impl.SimpleTransferSession;

public class Mysql2Mysql {
	
	
 	/**
	 * @param args
 	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		
		if (args.length!=3){
			System.out.println("Demo Usage: Mysql2Mysql URL User Password");
			System.exit(0);
		}
		
		String url = args[0];
		String user = args[1];
		String password = args[2];
		
		// create MySQL JDBC connection 
		Connection cnn = DriverManager.getConnection(url, user, password);
		
		SimpleTransferSession ts = new SimpleTransferSession(System.currentTimeMillis(), "test");
		DataSource ds = DataSourceFactory.createDataSource(cnn, null, null, "DEMO_TABLE");
		SourceMetaData smd = ds.getSourceMetaData();
		ts.setDataSource(ds);
		DestinationMetaData dmd = smd.createDestinationMetaData(cnn);
		dmd.setName("COPY_DEMO_TABLE");
		ts.setDestinationMetaData(dmd);
		ts.setDestConnection(cnn);
		
		
		ts.init();
		ts.validate();  // the statement is optional
		ts.execute();
		
		cnn.close();
		
	}




	

}
