package com.idata.etl;

import java.sql.Connection;
import java.sql.SQLException;

import com.idata.config.db.TypeConfigException;

public class DataSourceFactory {
	
	private DataSourceFactory(){}

	public static DataSource createDataSource(Connection cnn, String query) throws SQLException, ParseException,
			TypeConfigException {

		QueryDataSource qds = new QueryDataSource(cnn, query);
		qds.initMetaData();

		return qds;
	}

	public static DataSource createDataSource(Connection cnn, String catalog, String schema, String name)
			throws SQLException, ParseException, TypeConfigException {
		NativeDataSource nds = new NativeDataSource(cnn, catalog, schema, name);
		nds.initMetaData();
		return nds;
	}

}
